    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ------------------------
    028     * AreaRendererEndType.java
    029     * ------------------------
    030     * (C) Copyright 2004-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes:
    036     * --------
    037     * 29-April-2004 : Version 1 (DG);
    038     *
    039     */
    040
    041    package org.jfree.chart.renderer;
    042
    043    import java.io.ObjectStreamException;
    044    import java.io.Serializable;
    045
    046    /**
    047     * An enumeration of the 'end types' for an area renderer.
    048     */
    049    public final class AreaRendererEndType implements Serializable {
    050
    051        /** For serialization. */
    052        private static final long serialVersionUID = -1774146392916359839L;
    053
    054        /**
    055         * The area tapers from the first or last value down to zero.
    056         */
    057        public static final AreaRendererEndType TAPER = new AreaRendererEndType(
    058                "AreaRendererEndType.TAPER");
    059
    060        /**
    061         * The area is truncated at the first or last value.
    062         */
    063        public static final AreaRendererEndType TRUNCATE = new AreaRendererEndType(
    064                "AreaRendererEndType.TRUNCATE");
    065
    066        /**
    067         * The area is levelled at the first or last value.
    068         */
    069        public static final AreaRendererEndType LEVEL = new AreaRendererEndType(
    070                "AreaRendererEndType.LEVEL");
    071
    072        /** The name. */
    073        private String name;
    074
    075        /**
    076         * Private constructor.
    077         *
    078         * @param name  the name.
    079         */
    080        private AreaRendererEndType(String name) {
    081            this.name = name;
    082        }
    083
    084        /**
    085         * Returns a string representing the object.
    086         *
    087         * @return The string.
    088         */
    089        public String toString() {
    090            return this.name;
    091        }
    092
    093        /**
    094         * Returns <code>true</code> if this object is equal to the specified
    095         * object, and <code>false</code> otherwise.
    096         *
    097         * @param obj  the object (<code>null</code> permitted).
    098         *
    099         * @return A boolean.
    100         */
    101        public boolean equals(Object obj) {
    102
    103            if (this == obj) {
    104                return true;
    105            }
    106            if (!(obj instanceof AreaRendererEndType)) {
    107                return false;
    108            }
    109
    110            AreaRendererEndType t = (AreaRendererEndType) obj;
    111            if (!this.name.equals(t.toString())) {
    112                return false;
    113            }
    114
    115            return true;
    116
    117        }
    118
    119        /**
    120         * Ensures that serialization returns the unique instances.
    121         *
    122         * @return The object.
    123         *
    124         * @throws ObjectStreamException if there is a problem.
    125         */
    126        private Object readResolve() throws ObjectStreamException {
    127            Object result = null;
    128            if (this.equals(AreaRendererEndType.LEVEL)) {
    129                result = AreaRendererEndType.LEVEL;
    130            }
    131            else if (this.equals(AreaRendererEndType.TAPER)) {
    132                result = AreaRendererEndType.TAPER;
    133            }
    134            else if (this.equals(AreaRendererEndType.TRUNCATE)) {
    135                result = AreaRendererEndType.TRUNCATE;
    136            }
    137            return result;
    138        }
    139
    140    }